import vector_op as vec
import math

#
# An arc is a curly part of a Line
#
class Arc:
	# An arc..
	def __init__(self, center, radius, start_phi, end_phi):
		self.type = 'a'
		# members

		self.start_phi = start_phi	# in radians
		self.end_phi = end_phi

		#if end_phi > start_phi:
		#	if end_phi - start_phi < math.pi:
		#		self.delta_phi = end_phi - start_phi
		#	else:
		#		self.delta_phi = start_phi - end_phi
		#else:
		#	if start_phi - end_phi < math.pi:
		#		self.delta_phi = end_phi - start_phi
		#	else:
		#		self.delta_phi = start_phi - end_phi

		#if self.delta_phi > math.pi:
		#	self.delta_phi = self.delta_phi - math.pi*2

		if (end_phi > start_phi and end_phi - start_phi < math.pi) or (end_phi < start_phi and start_phi - end_phi < math.pi):
			self.delta_phi = end_phi - start_phi
		else:
			self.delta_phi = start_phi - end_phi

		if self.delta_phi > math.pi:
			self.delta_phi = math.pi*2 - self.delta_phi
		elif self.delta_phi < - math.pi:
			self.delta_phi = -math.pi*2 - self.delta_phi
	
		self.radius = radius
		self.center = center

		#self.delta_phi = end_phi - start_phi
		self.length = radius * abs( self.delta_phi )
	
	# Returns the 2-Dimension position of the point
	# located at 's', Direction is signed by 'd':1|-1
	#
	# If d is -1, then it's counted from the end-point, else
	# from the start-point
	#
	def getPos(self, s, d):
		if s > self.length:
			raise Exception('Arc not long enough') ## DEBUG
		
		if d == -1:
			base = self.end_phi
		else:
			base = self.start_phi

		#phi = base + s/self.length * d*self.delta_phi
		phi = base + s/self.length * d*self.delta_phi
		#phi = base + s/self.length * d*dp
		return vec.add(self.center, vec.mul(self.radius, (math.cos(phi), math.sin(phi))))
