import sys, pygame
from pygame.locals import *

pygame.init()

size = width, height = 256, 256

font_file = "train/STEAMER.TTF"
font_size = 12
charset_file = "font.tga"

screen = pygame.display.set_mode(size)

def render_charset(font_file, point_size):
	cell_size = width / 16
	disp = pygame.Surface((width, height), SRCALPHA, 32)
	font = pygame.font.Font(font_file, point_size)

	a = 0
	for y in range(16):
		for x in range(16):
			s = None
			try:
				s = font.render(chr(a), True, (255, 255, 255))
				ts = s.get_size()
				disp.blit(s, ( x*cell_size + ((cell_size - ts[0]) / 2), y*cell_size + ((cell_size - ts[1]) /2) ))
			except pygame.error:
				pass
			a = a + 1

	return disp

charset = render_charset(font_file, font_size)

clock = pygame.time.Clock()

def draw_screen(disp, charset):
	disp.fill((0,0,0))
	disp.blit(charset, (0,0))

while 1:
	clock.tick(20)

	for event in pygame.event.get():
		if event.type == pygame.QUIT:
			sys.exit()
		elif event.type == pygame.KEYDOWN and event.key == K_ESCAPE:
			sys.exit()
		elif event.type == pygame.KEYDOWN and event.key == K_s:
			pygame.image.save(charset, charset_file)

	draw_screen(screen, charset)
	pygame.display.flip()

