from math import floor, sqrt

###############
## Resources
###############
RES_ARROW = 0
RES_HEAD = 1
RES_CAR = 2
RES_COALBASE = 3

################
## Click targets
#################
CLICK_COALBASE = 0
CLICK_TRAINHEAD = 1
CLICK_SWITCH = 2

COALBASE_RADIUS = 25
TRAINHEAD_RADIUS = 22
SWITCH_RADIUS = 15

############################
## Game and train constants
###########################
MAXPLAYERS = 3
DELTA_SCORE_PER_CAR = 0.2	# 5 sec = 1 point per car
DEFAULT_CARS	= 2			# Default number of cars pulled
MAX_CARS = 5				# Max number of cars pulled

MAX_COAL			= 55	# Max number of coal pieces
COAL_PILE_SIZE = int(sqrt(2.2*MAX_COAL))	# Let the CPS*(CPS+1)/2 > MAX_COAL


COAL_TAKE_INTERVAL = 300	# millisec
COAL_FORCE_BOOST	= 2.0	# MaxForce boost per coal

CAR_LENGTH		= 64	# be shorter than switch range
SWITCH_RANGE = 65.0		# !!! Switch range should be greater than car length
#CAR_MASS		= 15.0
FRICTION_FORCE	= 0.2	# Car mass is always > than Friction force!

SWITCH_ARROW_DIST1 = 40.0		# To draw a line-aligned arrow 
SWITCH_ARROW_DIST2 = 45.0


BUMP_SPEED_RATIO	= 0.3		# The speed to bump back with
BACKWARD_FORCE_RATIO = 1.0
BACKWARD_MAXFORCE_RATIO = 0.8

DELTA_FORCE = 0.1
DELTA_MAXFORCE = 0.1	# MaxForce fall per second
BR_FORCE = -5.0			# Maximum of breaking force
MAX_FORCE = 20.0		# Top of MaxForce

################
## Bid constants
################

MAX_ACTION_POINTS = 400
BASE_ACTION_POINTS = 50
DELTA_AP = 3

DELTA_BID_START = 10
DELTA_BID_INCREASE = 15
BID_REFUND_RATIO = 0.9


################
## Net constants
################
LOCAL_PLAYER = True

NET_UPDATE_VERSION = "U1"
NET_PLAYER_INIT_SELF = "PI"
NET_PLAYER_INIT_OTHER = "PO"
NET_PLAYER_CONNECT = "PC"
NET_END_LOBBY = "EL"
NET_READY = "RY"
NET_SETUP = "SU"

NET_DISCONNECT = "DC"

NET_EVENT_BID = "EB"
NET_EVENT_COAL = "EC"
NET_EVENT_FWDBACK = "EF"

NET_DEFAULT_PORT = 33402
NET_BUFFSIZE = 2048

NET_UPDATE_IVAL = 50  # msec
NET_FULL_UPDATE_IVAL = 1000  # msec

#####################
## Grpahics constants
#####################
# SCREEN_W = 640
# SCREEN_H = 480

COAL_X = 40
COAL_Y = 30

BID_TEXT_DIST = 45.0

STEAM_LIFE_TIME = 6000	#msec

ARROW_HIGHLIGHT_COLOR = (255, 0, 255)
NEUTRAL_ARROW_COLOR = (250, 250, 50)
FROZEN_ARROW_COLOR = (210, 210, 0)
ARROW_COLOR = (250, 250, 250)

PLAYER_COLORS = ((240, 0, 0), (0, 240, 0), (0, 0, 240), (0, 255, 255))

RAIL_FORWARD_BASE_STEP = 15.0
RAIL_BASE_LEN = 15.0

RAIL_INNER_SIDE = 7.0
RAIL_OUTER_SIDE = 10.0

RAIL_FORWARD_STEP = 3.0

WHITE = (255, 255, 255)

####################
## Directories
####################
MAP_PATH = "maps"
IMAGE_PATH = "images"
MUSIC_PATH = "music"

MUSIC_MENU = 0
MUSIC_GAME = 1

####################
## Linepos constants
####################
LINE_REF_IDX = 0
LINE_POS_IDX = 1
LINE_END_IDX = 2

###################
## Switch constants
###################

SW_LINE_REF_IDX = 0
SW_LINE_END_IDX = 1

###################
## Player constants
###################



