from constants import *
from line import invertedLinePos, align1

def checkCollision(self):

	# Returns common line references
	def getCommonLines(tr1, tr2):
		lines = []
		
		tr1_tail_line = tr1.tail[0]
		tr2_tail_line = tr2.tail[0]
		tr1_head_line = tr1.head[0]
		tr2_head_line = tr2.head[0]
		
		
		if (tr1_head_line == tr2_head_line) or (tr1_head_line == tr2_tail_line):
			lines.append(tr1_head_line)
		
		if (tr1_tail_line == tr2_head_line) or (tr1_tail_line == tr2_tail_line):
			try:
				x = lines.index(tr1_tail_line)
			except ValueError:
				lines.append( tr1_tail_line )
		
		return lines
		
	# returns a list of  ( (tr1_A, tr1_B, 1|-1, 1|-1),(tr2_A, tr2_B, 1|-1, 1|-1) )
	def getIvals(lines, tr1, tr2):
		ret = []
		for ln in lines:
			x = []
			for train in (tr1, tr2):
				train_pos = [0.0, 0.0] # head, tail
				for pair in ((train.head, train.tail, 0), (train.tail, train.head, 1)):
					if pair[0][LINE_REF_IDX] == ln:
						#1-align
						train_pos[pair[2]] = align1(pair[0])
					else:
						if pair[1][LINE_END_IDX] == 1:
							#0
							train_pos[pair[2]] = 0
						else:
							#length
							train_pos[pair[2]] = ln.length
				if train_pos[0] > train_pos[1]:
					x.append( (train_pos[1], train_pos[0], -1, 1) )
				else:
					x.append( (train_pos[0], train_pos[1], 1, -1) )
			ret.append(x)
		return ret

	for pl1 in self.players:
		tr1 = pl1.train
		
		for pl2 in self.players:
			# pl1 checks ony players having id lesser than his
			if pl2.id >= pl1.id:
				break
			
			tr2 = pl2.train
			
			lines = getCommonLines(tr1, tr2)
			
			for ival1, ival2 in getIvals(lines, tr1, tr2):
			
				for i in (0, 1):
					if ( ival1[0] <= ival2[i] ) and ( ival2[i] <= ival1[1] ):
						front2back = False
						
						# ival2[i] coll ival1[1-i]
						if (ival2[i+2]==1) and (ival1[3-i]==1):
							# Frontal
							#print 'Frontal'
							# The train with higher speed wins
							if tr1.v > tr2.v:
								win, lose = tr1, tr2
							else:
								win, lose = tr2, tr1
								
							if lose.cars > 0 and win.cars < MAX_CARS:
								win.addCars(1)
								lose.removeCar()
							
							# Relocate the loser, slow the winner
							win.v -= lose.v
								# These lines are not interchangeable
							self.placeTrain(lose)
							
						elif (ival2[i+2]==-1) and (ival1[3-i]==1):
							# Train2 is hit by Train1
							# Steal a car
							
							front2back = True	
							a, b = tr1, tr2							
							
							#print 'Back1'
							
						elif (ival2[i+2]==1) and (ival1[3-i]==-1):
							# Train1 is hit by Train2
							
							front2back = True	
							b, a = tr1, tr2							
							
							#print 'Back2'
							
						elif (ival2[i+2]==-1) and (ival1[3-i]==-1):
							# Back-coillision
							# Invert train directions, reset force,
							# halve speed
							tr1.movesForward, tr2.movesForward = True, True
							tr1.force, tr2.force = 0.0, 0.0
							tr1.v /= 2
							tr2.v /= 2
							# Align ends
							tr2.tail = (tr2.tail[LINE_REF_IDX], invertedLinePos(tr1.tail)[LINE_POS_IDX] - 1.0, tr2.tail[LINE_END_IDX])
							tr2.alignToTail()
							#print 'Back2Back'
						
						if front2back:
							
							# Swap inertia (approximately)
							ov1 = a.v
							ov2 = b.v
							
							#print "speed before", ov1, ov2
							
							fwd1 = a.movesForward
							fwd2 = b.movesForward
							
							b.v = ov1 * (a.cars+1)/(b.cars+2)
							a.v = ov2 * (b.cars+1)/(a.cars+2)
							
							if b.cars > 0 and a.cars < MAX_CARS:
								a.addCars(1)
								b.removeCar()
							else:
								# Realign
								b.tail = (b.tail[LINE_REF_IDX], invertedLinePos(a.head)[LINE_POS_IDX] - 1.0, b.tail[LINE_END_IDX])
								b.alignToTail()
							
							#print "speed after", a.v, b.v
							
							# Swap force direction, (force direction if required)
							a.movesForward = fwd2
							b.movesForward = fwd1
							 
							a.force *= fwd1 * a.movesForward
							b.force *= fwd2 * b.movesForward
			
			
			
			
			
			 