########### Event handling

import pygame
from pygame.locals import *
from constants import *
from line import align1
from render import convertScreenPos

import config

def handleEvents(self):

	for event in pygame.event.get():
		if event.type == MOUSEBUTTONDOWN:
			# Scale event to 1024x768
			pos = convertScreenPos(event.pos)
			ev = self.getClickEvent(pos)
			
			if (ev):
				# Click-event to handle!! Yiiihaaa!!
				#
				if ev[0] == CLICK_SWITCH:
					# If left-click, then detect state
					if event.button == 1:
						ev[1].clickArrow(ev[2])
					
					# Also, if there is a preferred state now
					# (by right or left click), send it
					if ev[1].preferredState is not False:
						bid = ev[1].bid
						# How much we give for that
						amount = bid.delta_bid + bid.topbid - bid.player_bids[self.own_id]
						# Make it
						self.eventhandler.eventBid(self.ownplayer, ev, ev[1].preferredState, amount)
				
				elif ev[0] == CLICK_TRAINHEAD:
					# Left-click means put more coal in chamber
					if event.button == 1:
						self.eventhandler.eventPutCoal(self.ownplayer)
				
				elif ev[0] == CLICK_COALBASE:
					# Send the click to the event handler
					self.eventhandler.eventGetCoal(self.ownplayer, ev)
		
		elif event.type == MOUSEMOTION:
 			pos = convertScreenPos(event.pos)
			ev = self.getClickEvent(pos)
			
			if (ev):
				## May change mouse cursor accordingly
				if ev[0] == CLICK_SWITCH:
					# Do a local highlight for the arrow
					ev[1].highlightArrow = ev[2]
				
				
		elif event.type == KEYDOWN:

			# Forward event
			if event.key == K_w:
				self.eventhandler.eventFwd(self.ownplayer, True)
			
			# Backward event
			if event.key == K_s:
				self.eventhandler.eventBack(self.ownplayer, True)
			
			if event.key == K_ESCAPE:
				# Quit event
				return False
			
		elif event.type == KEYUP:
			
			# Forward event
			if event.key == K_w:
				self.eventhandler.eventFwd(self.ownplayer, False)
			
			# Backward event
			if event.key == K_s:
				self.eventhandler.eventBack(self.ownplayer, False)
				
	return True
			

### Event handlers
	
# Forward key on train
def eventFwd(self, player, press):
	player.train.forward(press)

# Backward key on train
def eventBack(self, player, press):
	player.train.backward(press)
	
# Click on a coal-base
def eventGetCoal(self, player, event):
	# event is (constant, line_ref of coalbase, position)
	# Check if the head is on the line of the coalbase,
	# in the right position
	if player.train.coal == MAX_COAL:
		return
	
	if self.time < player.canTakeCoal:
		return
		
	head = player.train.head
	line = event[1]
	
	if head[LINE_REF_IDX] == line:
	
		headpos = align1(head)
		if (line.coal[0] <= head[LINE_POS_IDX]) and (head[LINE_POS_IDX] <= line.coal[1]):
			# Access to coal is all right
			player.train.addCoal(1)
			player.canTakeCoal += COAL_TAKE_INTERVAL
			

# Click on train -> puts coal in engine chamber
def eventPutCoal(self, player):
	player.train.putCoal()
	

# Bid on a switch
def eventBid(self, player, event, state, amount):
	# event is: (constant, switch, pair)
	event[1].bidForState(player, state, amount)

	

	
	
	
	