from struct import calcsize

# signed char: b
# unsigned char: B
# short: h
# ushort: H
# f: float

#####################
## Disconnect
#####################
disconFormat = "!2s" # 'DC'

#####################
## Event formats
#####################
eventFwdBackFormat = "!2sBB" # 'EF', forward, press
eventCoalFormat = "!2sBHHH" # 'EC', putCoal, lineid, posx, posy
eventBidFormat = "!2sBHH" # 'EB', state, sw id, amount

#####################
## Player Connect req
#####################
playerConnectFormat = "!2s16s" # 'PC', 16byte name
playerConnectSize = calcsize(playerConnectFormat)

####################
## Setup Game pkg
####################
setupGameFormat = "!2s16sH" # "SU", map name, max points
setupGameSize = calcsize(setupGameFormat)

#############################
## End Lobby pkg, ready pkg
#############################
shortMsgFormat = "!2s" # "EL"/"RY" end lobby, ready
shortMsgSize = calcsize(shortMsgFormat)

######################
## Player init package
######################
playerInitFormat = "!2sBBBB16s" # 'PI'/'PO' id, 3byte col, 16byte name
playerInitSize = calcsize(playerInitFormat)

#################
## Update Package
#################
playerFormat = "!BHHdbHdbBBdddBBB" # id, score, head, tail, cars, moveFwd, v, force, maxforce,  isBraking, doSpeedup, doBrake
playerSize = calcsize(playerFormat)

switchFormat = "!HBBBBBHHB" # sw.id, sw.state, sw.trPass, sw.trStPass, topplayer, topstate, topbid, dbid, frozen
switchSize = calcsize(switchFormat)

updateHeaderFormat = "!2sIBH" # 'U1', package_count #players, #switches
updateHeaderSize = calcsize(updateHeaderFormat)

#######################
## Update private addon
#######################
privateFormat = "!HH" # action_points, coal
privateSize = calcsize(privateFormat)
