from constants import *
from train import *

class Player:

	def __init__(self, id, gamestate, name, color, baseInit = True):
		self.id = id
		self.gamestate = gamestate
		self.name = name
		self.color = color
		
		self.score = 0
		self.action_points = BASE_ACTION_POINTS
				
		if baseInit:
			self.train = Train(gamestate, self)
		
		## Event-related members follow
		## These are not required to synchronize
		self.canTakeCoal = 0
			# Stores the time in millisecs, when can the
			# player get his next stock of coal
	
class GPlayer(Player):

	def __init__(self, id, gamestate, name, color, resources):
		Player.__init__(self, id, gamestate, name, color, False)
				
		self.train = GTrain(gamestate, self, resources)
		
	# Render trains, score
	def render(self):
		self.train.render()
	