from engine import gamestate, player, render

import pygame
from pygame.locals import *

from OpenGL.GL import *
from OpenGL.GLU import *

pygame.init()
pygame.display.set_mode((640, 480), OPENGL | HWSURFACE | DOUBLEBUF)

glClearColor(0.0, 0.0, 0.0, 0.0)
glClear(GL_COLOR_BUFFER_BIT)
glMatrixMode(GL_PROJECTION)
glOrtho(0, 639, 0, 479, -1, 1)
glMatrixMode(GL_MODELVIEW)

gamestate.init()

gs = gamestate.Gamestate()
ron = player.Player(0, gs, "Ron", (255, 250, 20))
gs.addPlayer( ron )

gs.loadMapFile('proba.map')


gs.switches[1].bid.topstate = 1

ron.train.head = (gs.lines[0], 160, 1)
ron.train.v = 0.05
ron.train.alignToHead()

for l in gs.lines:
	print l.id, l, l.start_switch, l.end_switch

for s in gs.switches:
	print s.id, s.states

	
c = pygame.time.Clock()

c.tick()
while True:
	for sw in gs.switches:
		sw.beginRound()
		sw.refresh()
	
	ron.train.move(c.tick())
	
	for sw in gs.switches:
		sw.endRound()
	
	glClear(GL_COLOR_BUFFER_BIT)
	
	for ln in gs.lines:
		render.renderLineBase(ln)
		render.renderLineTop(ln)
	
	#for ln in gs.lines:
	#	render.renderLineTop(ln)
		
	gs.render()
	glFlush()
	pygame.display.flip()
	
	for event in pygame.event.get():
		if event.type == KEYDOWN:
			if event.key == K_s:
				gs.switches[1].bidForState(ron, 0)
				#gs.switches[1].bid.topstate = 1 - gs.switches[1].bid.topstate
				#print 'switching sw#1 to', gs.switches[1].bid.topstate
			
			if event.key == K_a:
				ron.train.cars += 1
				#gs.switches[1].bidForState(ron, 1)
				
				#gs.switches[0].bid.topstate = 1 - gs.switches[0].bid.topstate
				#print 'switching sw#0 to', gs.switches[0].bid.topstate
			
	
