from engine import gamestate, player, render, image, panel as grpanel, net as network, resources as res
from engine.constants import *

import pygame
from pygame.locals import *

from OpenGL.GL import *
from OpenGL.GLU import *

from engine import  config
config.SCREEN_W = 640
config.SCREEN_H = 480

pygame.init()
pygame.display.set_mode((640, 480), OPENGL | HWSURFACE | DOUBLEBUF | FULLSCREEN*0)

glClearColor(0.2, 0.35, 0.1, 0.0)
glClear(GL_COLOR_BUFFER_BIT)
glMatrixMode(GL_PROJECTION)
glOrtho(0, 1023, 0, 767, -1, 1)
glMatrixMode(GL_MODELVIEW)

##############
## Load images
##############
resources = res.Resources()
gamestate.init()
gs = gamestate.GGamestate(resources)

# Create net system
net = network.Net(gs, resources)
gs.eventhandler = net

# Connect to the server
net.connectToServer("Gyaa", "ron.sch.bme.hu")

# Wait until game starts
while net.update_pkg_count == 0:
	pygame.time.wait(20)
	net.clientRead()

gs.startGame()
while gs.game:
	gs.doTime(net)
	
	
	