from engine import gamestate, player, render, net as network
from engine.constants import *

### DEBUG
import timing
import psyco

import pygame
from pygame.locals import *

from OpenGL.GL import *
from OpenGL.GLU import *

pygame.init()
pygame.display.set_mode((640, 480), OPENGL | HWSURFACE | DOUBLEBUF)

glClearColor(0.0, 0.0, 0.0, 0.0)
glClear(GL_COLOR_BUFFER_BIT)
glMatrixMode(GL_PROJECTION)
glOrtho(0, 639, 0, 479, -1, 1)
glMatrixMode(GL_MODELVIEW)


# Create blank gamestate
gamestate.init()
gs = gamestate.Gamestate()

# Create net system
net = network.Net(gs)

# Connect to the server
net.connectToServer("Gyaa", "localhost")

# Wait until game starts
while net.update_pkg_count == 0:
	net.clientRead()


# Start riding

c.tick()
currentTime = 0

#psyco.profile()

while True:
	## Measure delta time
	## Not used in client yet
	delta_msec = c.tick()
	currentTime += delta_msec
	dt = delta_msec #/ 1000.0
	
	############################
	##### Modelling stage begins
	############################
	
	## Maybe later
	#for pl in gs.players:
	#	pl.train.move(dt*gs.speedCorrection)
	
	###########################
	## Drawing phase
	###########################
	glClear(GL_COLOR_BUFFER_BIT)
	
	for ln in gs.lines:
		render.renderLineBase(ln)
		render.renderLineTop(ln)
	
	gs.render()
	glFlush()
	pygame.display.flip()
	
	###########################
	## Network receive phase
	###########################
	net.clientRead()
			
	#########################################
	## Event handling and network send phase
	#########################################
	for event in pygame.event.get():
		# Handle events
		pass
		
	################
	## Sleep phase
	################
	if currentTime % 1000 < 20:
		print "speedCorrection:", gs.speedCorrection
	#	print 'FPS', c.get_fps()
	pygame.time.wait(5)