from engine import gamestate, player, render, image, panel as grpanel, net as network, resources as res
from engine.constants import *

import pygame
from pygame.locals import *

from OpenGL.GL import *
from OpenGL.GLU import *

pygame.init()
pygame.display.set_mode((SCREEN_W, SCREEN_H), OPENGL | HWSURFACE | DOUBLEBUF | FULLSCREEN*0)

glClearColor(0.2, 0.35, 0.1, 0.0)
glClear(GL_COLOR_BUFFER_BIT)
glMatrixMode(GL_PROJECTION)
glOrtho(0, 1023, 0, 767, -1, 1)
glMatrixMode(GL_MODELVIEW)

gamestate.init()

##############
## Load images
##############

resources = res.Resources()
gs = gamestate.GGamestate(resources)

# Create net system
net = network.Net(gs, resources)

## Add our player manually
ron = player.GPlayer(0, gs, "Ron", gs.nextColor(), resources)
gs.addPlayer(ron, LOCAL_PLAYER)

# Create server
net.createServer()

# Wait for other players
while len(gs.players) < 2:
	pygame.time.wait(20)
	net.serverRead()

# Setup Game
net.setupGame("test1.map", 2000)


gs.startGame()
while gs.game:
	gs.doTime(net)
		
	
	
	