import panel, image, config, os
import pygame

from constants import *
from OpenGL.GL import GL_NEAREST

# Resource class, loads all images and stuff

class Resources:
	
	def __init__(self):
		self.head = (image.Image("engine_color.png"), image.Image("engine.png"))
		self.car = (image.Image("car_color.png"), image.Image("car.png"))

		self.arrow = image.Image("arrow.png")
		self.steam = image.Image("goz.png")
		
		self.font = ( image.Image("font0.png"), image.Image("font1.png") )
		self.panel = panel.Panel()
				
		self.train = []
		# Load the train
		for x in range(0,8):
			for y in range(0,6,1):
				self.train.append( (image.Image("bg/bg-"+str(y)+"-"+str(x)+".png", filter = GL_NEAREST), (x*128, 768-(1+y)*128)) )
		
		# Bg will be registered in pre-render phase
		self.bg = []
		
		self.musicList = ("sihuhuhu.mp3", "vonat.mp3")
		self.music = None
		
	def playMusic(self, which):
		if config.music:
			if self.music != which:
				self.music = which
				try:
					pygame.mixer.music.fadeout(500)
					pygame.mixer.music.load(os.path.join(MUSIC_PATH, self.musicList[which]))
					pygame.mixer.music.play(-1)
				except Exception:
					print "Music system error, disabling music."
					config.music = False
	
		
	# Renders the background
	def renderBg(self):
		for bg in self.bg:
			bg[0].draw(bg[1])
			
	def renderTrain(self):
		for train in self.train:
			train[0].draw(train[1])
			
	
	# Prints the text
	def puttxt(self, pos, text, color, center=False, right=False):
		i = 0
		mod = 0
		if center:
			mod -= len(text)/2 * 16
		if right:
			mod -= len(text) * 16
		
		for c in text:
			y = ord(c) / 16
			x = ord(c) - 16*y
			if x<8:
				font = self.font[0]
			else:
				font = self.font[1]
				x -= 8
			
			font.puttxt((mod+pos[0]+i*16, pos[1]), (x,y), color)
			i += 1

	