import vector_op as vec
from constants import *

#
# A segment is a straight part of a Line
#
class Segment:
	
	# A segment pointing from 'start' to 'end'	
	def __init__(self, start, end):
		self.type = 's'
		# members
		self.start = start	# (x,y) floats
		self.end = end
		
		v = vec.vector(start, end)
		self.vector = vec.norm(v)
		self.length = vec.length(v)
	
	# Returns the 2-Dimension position of the point
	# located at 's', Direction is signed by 'd':1|-1
	#
	# If d is -1, then it's counted from the end-point, else
	# from the start-point
	#
	def getPos(self, s, d):
		if s > self.length:
			raise Exception('Segment not long enough') ## DEBUG
		
		if d == -1:
			base = self.end
		else:
			base = self.start
		return vec.add(base, vec.mul(s*d, self.vector))

