import math

# substract 'start' from 'end'
def vector(start, end):
	return (end[0]-start[0], end[1]-start[1])

# vector addition
def add(v1, v2):
	return ( v1[0]+v2[0], v1[1]+v2[1] )

# multiply by scalar value
def mul(s, v):
	return ( v[0]*s, v[1]*s )

# length of vector
def length(v):
	return math.sqrt( v[0]**2 + v[1]**2  )

# normal of vector
def norm(v):
	return mul(1.0/length(v), v)
	
def distance(v1, v2):
	return length(vector(v2, v1))