###########################################################
# SteamCatcher v0.1
# (C) MindlessGameStudio, 2006 (wow, it's 2006 already..)
#
# A game of catching each other with trains
#
# Comes with no warranty, we are not responsible for
# the program's making any kind of damage to anything.
#
# Source code is under GPL, in fact some script
# should be included to all file headers.. Just
# imagine that they are there :)
#

from engine import gamestate, player, render, net as network, resources as res, config
import sys

from engine.menu import Menu
from engine.constants import *

try:
	import pygame
	from pygame.locals import *
except Exception(e):
	print "Could not import pygame. Please make sure that pygame is installed!"
	raise e

try:
	from OpenGL.GL import *
	from OpenGL.GLU import *
except Exception(e):
	print "Could not import OpenGL. Please make sure that pyopengl is installed!"
	raise e



###############################################
## Get video and audio options from console
##############################################
# Default values
config.psyco = True
config.fullscreen = 1
config.SCREEN_W = 800
config.SCREEN_H = 600
config.music = True


# print an usage
print "Steamcatcher v0.1 - written by Mindless Game Studio"
print "Additional switches:"
print " -dm    Disable music"
print " -w     Windowed mode"
print " -dp    Disable psyco"
print " -1024  1024x768 mode (default)"
print " -800   800x600 mode"
print " -640   640x480 mode"


if "-dm" in sys.argv:
	config.music = False
if "-w" in sys.argv:
	config.fullscreen = False
if "-dp" in sys.argv:
	config.psyco = False
if "-1024" in sys.argv:
	config.SCREEN_W, config.SCREEN_H = 1024, 768
if "-800" in sys.argv:
	config.SCREEN_W, config.SCREEN_H = 800, 600
if "-640" in sys.argv:
	config.SCREEN_W, config.SCREEN_H = 640, 480
	
try:
	if config.psyco:
		import psyco
except Exception:
	print "Could not load psyco, disabling it."
	config.psyco = False


render.init()


####################
## Load resources
####################

resources = res.Resources()

##################
## Display menu
##################

menu = Menu(resources)

if config.psyco:
	psyco.profile()

stayInMenu = True
while stayInMenu:
	resources.renderTrain()

	stayInMenu = menu.doMenu()
	
	glFlush()
	pygame.display.flip()
	pygame.time.wait(20)

pygame.quit()